﻿using pdftron;
using pdftron.PDF;
using System.Reflection;
using System.Runtime.InteropServices;

// configure

var binDir = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);

var platformDir = RuntimeInformation.IsOSPlatform(OSPlatform.Windows)
    ? "HTML2PDFWindows"
    : RuntimeInformation.IsOSPlatform(OSPlatform.Linux)
    ? "HTML2PDFLinux"
    : throw new InvalidOperationException();

var tronPlatformFilesDir = Path.Combine(binDir, "PdfTron", platformDir);

PDFNet.Initialize("demo:1644348369798:7b099f6c03000000002f1e7f2d9dcf98ad83951f9e8e7aaf859b0fd524");
HTML2PDF.SetModulePath(tronPlatformFilesDir);

// begin test

using var doc = new PDFDoc();
using var converter = new HTML2PDF();

// add from HTML String data
converter.InsertFromHtmlString("<html><body><h1>Heading</h1><p>Paragraph.</p></body></html>");

// apply conversion
if (converter.Convert(doc))
{
    doc.Save(@"C:\temp\output.pdf", pdftron.SDF.SDFDoc.SaveOptions.e_linearized);
    Console.WriteLine(@"Success: C:\temp\output.pdf");
}
else
{
    Console.WriteLine($"PdfTron converter returned a bad flag :( {converter.GetHTTPErrorCode()}{Environment.NewLine}{converter.GetLog()}");
}

